<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use \Exception as Exception;

class ParaTerminalConsultaController extends \Zeedhi\Framework\Controller\Simple {

	protected $paraTerminalConsultaService;
	protected $util;
	protected $environment;


	public function __construct(Services\ParaTerminalConsultaService $paraTerminalConsultaService, Utilities\Util $util) {
		$this->paraTerminalConsultaService 	 = $paraTerminalConsultaService;
		$this->util                          = $util;
		
	}

    public function findCaixas(Request\Filter $request, Response $response) {
        $conditions = $this->util->getParamsAsArray($request);
        $caixas = $this->paraTerminalConsultaService->findCaixas($conditions);
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('paraTerminalConsultaCaixas', $caixas));
    }
    
    
    public function saveAll (Request $request, Response $response) {
    	$row = $this->util->getParamsAsArray($request);

    	try {
    		$this->paraTerminalConsultaService->saveAll($row);
    		$response->addMessage(new Message("Registro atualizado!"));
    	} catch (Exception $e) {
    		$response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
    	}	
    }
    
    public function findProdFili (Request\Filter $request, Response $response) {
    	$conditions = $this->util->getParamsAsArray($request);
        $products = $this->paraTerminalConsultaService->findProdFili($conditions);
        $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('paraTerminalConsultaCaixas/produtos', $products));
    }
    
    public function saveProdFili (Request $request, Response $response) {
        $row = $this->util->getParamsAsArray($request);
    	try {
    		$this->paraTerminalConsultaService->saveProdFili($row);
    		$response->addMessage(new Message("Registro salvo!"));
    	} catch (Exception $e) {
    		$response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
    	} 
    }
    
    public function editProdFili (Request $request, Response $response) {
        $row = $this->util->getParamsAsArray($request);
    	try {
    		$this->paraTerminalConsultaService->editProdFili($row);
    		$response->addMessage(new Message("Registro salvo!"));
    	} catch (Exception $e) {
    		$response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
    	} 
    }
    
    public function deleteProdFili (Request $request, Response $response) {
        $row = $this->util->getParamsAsArray($request);
    	try {
    		$this->paraTerminalConsultaService->deleteProdFili($row);
    		$response->addMessage(new Message("Registro deletado!"));
    	} catch (Exception $e) {
    		$response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
    	} 
    }
}